
#ifdef _OPENMP
    #include <omp.h>
#endif

#define ASSERT(x)                    \
{                                    \
    if (!(x)) {                      \
        cerr << "assert failed line " << __LINE__ << ", file " << __FILE__ << ": #x\n"; \
        exit(1);                     \
    }                                \
}

#ifdef _OPENMP
    #define threads_omp()      \
    ({                         \
        omp_set_dynamic(false);\
        omp_set_num_threads(1);\
    })
#else
    #define threads_omp()
#endif

